$RM::Range = 256;
$RM::Version = 2;

function servercmdradio(%client, %mode, %arg1, %arg2)
{
	%this = RM_TCP;
	switch$(%mode)
	{
	 case "help":
		messageclient(%client, '', "\c6Help:");
		messageclient(%client, '', "\c6- /radio channel <channel> - Sets chat to the given channel, 1-1000");
		messageclient(%client, '', "\c6- /radio check connection - Tells you your connection status");
		
	 case "channel":
		if(%arg1 < 0 || %arg1 > 1000)
		{
			messageclient(%client, '', "\c6That's not a valid channel!");
			return;
		}
		%client.Radio["Channel"] = %arg1;
		messageclient(%client, '', "\c6Tuned to channel \c3" @ %arg1);
		
	 case "check":
		InitContainerRadiusSearch(%client.player.gettransform(), $RM::Range, $typemasks::fxbrickobjecttype);
		while((%brick = containersearchNext()) != 0)
		{
			if(%brick.radioTower["Connected"])
			{
				%send = 1;
			}
		}
		if(%send)
			messageclient(%client, '', "\c6You \c3are \c6connected to the radio.");
		else
			messageclient(%client, '', "\c6You \c3arn't \c6connected to the radio.");
	}
}

//==================================================
//(4) Bricks
//==================================================

datablock fxDTSBrickData (brickRadioData : brick2x2x5girderdata)
{
	category = "Special";
	subCategory = "Radio";
	uiName = "Radio Tower";
};

exec("Add-Ons/Brick_Large_Cubes/server.cs");
$Addonloaded__Brick_Large_Cubes = 1;
//Still looking for a modeler
datablock fxDTSBrickData (brickSatelliteData : brick16xCubeData)
{
	category = "Special";
	subCategory = "Radio";
	uiName = "Satellite Dish";
	radiosat = 1;
};

function RM_onplantbrickhandle(%this)
{
	%data = %this.getDatablock();
	if(!isobject(%this))
		return;
		
	InitContainerRadiusSearch(%this.getTransform(), $RM::Range, $typemasks::fxbrickobjecttype);
	while((%brick = containersearchNext()) != 0)
	{
		if(%brick.getDatablock().radiosat)
		{
			%connected = 1;
			%this.sourceL = "" TAB %brick;
			%this.sourceS = %brick;
			%this.RadioTower["Connected"] = 1;
			break;
		}
		
		if(%brick.RadioTower["Connected"])
		{
			%this.sourceL = %brick.sourceL TAB %brick;
			%this.sourceS = %brick;
			%this.RadioTower["Connected"] = 1;
			break;
		}
	}
	if(!%this.RadioTower["Connected"])
	{
		messageclient(%this.client, '', "\c6This brick is out of range!");
		%this.killbrick();
		return;
	}
	
	if(!isobject(RadioTowerGroup))
	{
		new ScriptGroup(RadioTowerGroup);
		mainBrickGroup.add(RadioTowerGroup);
	}
	%this.isplanted = 1;
	RadioTowerGroup.add(%this);
}

//==================================================
//(5) Package
//==================================================

package Radio
{
	function servercmdMessageSent(%client, %msg)
	{
		if(getsubstr(%msg, 0, 1) $= "#")
		{
			if(isobject(%client.player))
			{
				if(%client.Radio["Channel"] $= "")
				{
					messageClient(%client, '', "\c6Woops, looks like you havn't tuned to a channel yet! Type \c3/radio help\c6 for help!");
					return;
				}
				
				InitContainerRadiusSearch(%client.player.gettransform(), $RM::Range, $typemasks::fxbrickobjecttype);
				while((%brick = containersearchNext()) != 0)
				{
					if(%brick.radioTower["Connected"])
					{
						%send = 1;
						%sendbrick = %brick;
						break;
					}
				}
				if(%send)
				{
					for(%a = 0; %a < ClientGroup.getCount(); %a++)
					{
						%cl = ClientGroup.getobject(%a);
						%send2 = 0;
						if(%client.Radio["Channel"] == %cl.Radio["Channel"])
						{
							InitContainerRadiusSearch(%cl.player.gettransform(), $RM::Range, $typemasks::fxbrickobjecttype);
							while((%brick = containersearchNext()) != 0)
							{
								if(%brick.radioTower["Connected"] && !%stop)
								{
									%send2 = 1;
									break;
								}
							}
							if(%send2)
							{
								messageclient(%cl, '', "\c4[" @ %client.Radio["Channel"] @ "]" @ getsubstr(%client.name, 0, 3) @ getsubstr(%client.bl_id, 0, 3) @ "\c6: " @ getsubstr(%msg, 1, 255));
							}
						}
					}
					%brick = %sendbrick;
					%brick.setcolorfx(3);
					%brick.schedule(250,setcolorfx, 0);
					for(%b = 1; %b < getfieldcount(%brick.sourceL); %b++)
					{
						%br = getfield(%brick.sourceL, %b);
						%br.setcolorfx(3);
						%br.schedule(250,setcolorfx, 0);
					}
				}
				else
					messageclient(%client, '', "\c6You are out of range of a working Radio Tower!");
			}
		}
		else
			parent::servercmdMessageSent(%client, %msg);
	}
	
	function GameConnection::onClientEnterGame(%client)
	{
		parent::onClientEnterGame(%client);
		messageclient(%client, '', "\c2Server is running Dephurites' Radio Mod version \c6" @ $RM::Version @ "\c2.");
	}
	
	function fxDTSBrick::onPlant(%this, %a, %b, %c, %d, %e)
	{
		echo("onPlant");
		parent::onPlant(%this, %a, %b, %c, %d, %e);
		if(%this.getDatablock().getName() $= "brickRadioData")
			schedule(100, 0, RM_onplantbrickhandle, %this);
	}

	function fxDTSBrick::killbrick(%this)
	{
		if(%this.isplanted && !%this.Radio["Delete"] && %this.getDatablock().getname() $= "brickRadioData")
		{
			for(%a = 0; %a < RadioTowerGroup.getcount(); %a++)
			{
				%radio = RadioTowerGroup.getobject(%a);
				if(strpos(%radio.sourceL, "" TAB %radio) > -1)
				{
					%radio.Radio["Delete"] = 1;
					%radio.killbrick();
				}
			}
		}
		parent::killbrick(%this);
	}
};
activatepackage(Radio);